function [period,table]=getperiod(type,levels,fieldset1,fieldset2,fieldset3,fieldset4,fieldset5,fieldset6,periodset1,periodset2,periodset3,periodset4,periodset5,periodset6,periodset7,periodset8,periodset9,periodset10,periodsetsmerged)

% This is a function for the createsignal program that inputs and validates a signal period and returns the period, the field and the half parent signal for two methods of creating input signals 

% Input the period, reject obviously invalid entries and obtain the nearest valid periods

period=input('Enter the preferred signal period ');     % enter period
disp(' ')
table=zeros(6,8);                                       % basic table
if      isempty(period)||~isnumeric(period)||period~=round(period)||period<=0
        disp(['  Invalid entry. Enter a period between ',int2str(min(periodsetsmerged)), ' and ',int2str(max(periodsetsmerged)), ' inclusive',]) % error message
        disp(' ')
        [period,table]=getperiod(type,levels,fieldset1,fieldset2,fieldset3,fieldset4,fieldset5,fieldset6,periodset1,periodset2,periodset3,periodset4,periodset5,periodset6,periodset7,periodset8,periodset9,periodset10,periodsetsmerged); % return if invalid
elseif  period<min(periodsetsmerged)
        disp(['  ',int2str(period),' is not the period of a Class ',int2str(type),', ',int2str(levels),'-level input signal that can be created']) % error message
        disp(['  ',int2str(min(periodsetsmerged)),' is the nearest period of a Class ',int2str(type),', ',int2str(levels),'-level input signal that can be created']) % range of periods
        disp(' ')
        [period,table]=getperiod(type,levels,fieldset1,fieldset2,fieldset3,fieldset4,fieldset5,fieldset6,periodset1,periodset2,periodset3,periodset4,periodset5,periodset6,periodset7,periodset8,periodset9,periodset10,periodsetsmerged); % return if invalid
elseif  period>max(periodsetsmerged)
        disp(['  ',int2str(period),' is not the period of a Class ',int2str(type),', ',int2str(levels),'-level input signal that can be created']) % error message
        disp(['  ',int2str(max(periodsetsmerged)),' is the nearest period of a type ',int2str(type),', ',int2str(levels),'-level input signal that can be created']) % range of periods
        disp(' ')
        [period,table]=getperiod(type,levels,fieldset1,fieldset2,fieldset3,fieldset4,fieldset5,fieldset6,periodset1,periodset2,periodset3,periodset4,periodset5,periodset6,periodset7,periodset8,periodset9,periodset10,periodsetsmerged); % return if invalid
end       
periodsdifference=periodsetsmerged-period;              % subtract period from periodsetsmerged
[minimum,index]=min(abs(periodsdifference));            % get minimum and index
if      minimum~=0                                      % if period is not valid
        if  periodsdifference(index)>0                  % prepare for adjacent periods
            index=index-1;                              % decrement index
        end
        disp(['  ',int2str(period),' is not the period of a Class ',int2str(type),', ',int2str(levels),'-level input signal that can be created']) % error message
        disp(['  ',int2str(periodsetsmerged(index)),' and ',int2str(periodsetsmerged(index+1)),' are the nearest periods of Class ',int2str(type),', ',int2str(levels),'-level input signals that can be created']) %range of periods
        disp(' ')
        [period,table]=getperiod(type,levels,fieldset1,fieldset2,fieldset3,fieldset4,fieldset5,fieldset6,periodset1,periodset2,periodset3,periodset4,periodset5,periodset6,periodset7,periodset8,periodset9,periodset10,periodsetsmerged); % return if invalid
else    period=periodsetsmerged(index);                 % valid period for either method of creation
end

% Get field for first method of creation

if  (type==0&&(levels==2||levels==3))||(type==1&&(levels==2))||(levels==3&&period<=max(periodset10)&&period/4~=round(period/4)) % Class 0 or 1 signals period not a multiple of 4

% Construct a table to show the field for Class 0 and Class 1

% Row 1 Column 1 is the field and the remaining elements are zero

    if      type==0
            table(1,1)=period;                          % get field for Class 0 signals
    else    table(1,1)=period/2;                        % get field for Class 1 signals
    end
end

% Get field and halfparent signal for second method of creation

if  type==2||(type==1&&(levels==5||levels==7))||type==1&&levels==3&&(period>max(periodset10)||period<=max(periodset10)&&(period/4==round(period/4))) % start of second method

% Construct tables to show the field and the half parent signal for each Class and number of levels

% The rows correspond to periodsets 1 to 6 respectively
% Column 1 is the field which is set to 0 initially
% Rows 1-6, columns 2-7 are the half parent signals corresponding to each periodset
% Column 8 is the order of the periodsets that gives maximum PIPS 

    if      type==1&&levels==3
            table=[0   1   0   0   0   0   0   1;
                   0   1   1   0   0   0   0   2;
                   0   0   0   0   0   0   0   0;
                   0   1   1  -1   0   0   0   4;
                   0   0   0   0   0   0   0   0;
                   0   1   1   1  -1   1   0   3];
    end
    if      type==1&&levels==5
            table=[0   0   0   0   0   0   0   0;
                   0   1   2   0   0   0   0   3;
                   0   1   2  -2   0   0   0   1;
                   0   1   2   0   2   0   0   4;
                   0   2   3   2  -2   2   0   5;
                   0   1   2   2   1  -2   2   2];
    end
    if      type==1&&levels==7
            table=[0   0   0   0   0   0   0   0;
                   0   0   0   0   0   0   0   0;
                   0   6  10 -15   0   0   0   4;
                   0   2  -3   6   6   0   0   3;
                   0   2  -3  -6  -6   6   0   2;
                   0   2   4  -2   4   3  -4   1];
    end
    if      type==2&&levels==3
            table=[0   0   0   0   0   0   0   0;
                   0   0   0   0   0   0   0   0;
                   0   1   1   0   0   0   0   1;
                   0   0   0   0   0   0   0   0;
                   0   0   0   0   0   0   0   0;
                   0   1   1   0   1  -1   0   2];
    end
    if      type==2&&levels==5
            table=[0   0   0   0   0   0   0   0;
                   0   0   0   0   0   0   0   0;
                   0   1   2   1   0   0   0   1;
                   0   0   0   0   0   0   0   0;
                   0   0   0   0   0   0   0   0;
                   0   1   1   2  -1   1  -2   2];
    end
    if      type==2&&levels==7
            table=[0   0   0   0   0   0   0   0;
                   0   0   0   0   0   0   0   0;
                   0   1   3   2   0   0   0   1;
                   0   0   0   0   0   0   0   0;
                   0   0   0   0   0   0   0   0;
                   0   1   2   3  -1   2  -3   2];
    end

    % Get all fields corresponding to the period
     
    if      intersect(period,periodset1)==period        % if period is in periodset1 and periodset1 is relevant
            if  table(1,8)~=0
                table(1,1)=(period-2)/2;                % get corresponding field
            end
    end
    if      intersect(period,periodset2)==period        % if period is in periodset2 and periodset2 is relevant
            if  table(2,8)~=0
                table(2,1)=(period-4)/4;                % get corresponding field
            end                                         
    end
    if      intersect(period,periodset3)==period        % if period is in periodset3 and periodset3 is relevant
            if  table(3,8)~=0
                table(3,1)=(period-6)/6;                % get corresponding field
            end                                         
    end
    if      intersect(period,periodset4)==period        % if period is in periodset4 and periodset4 is relevant
            if  table(4,8)~=0
                table(4,1)=(period-8)/8;                % get corresponding field
            end
    end
    if      intersect(period,periodset5)==period        % if period is in periodset5 and periodset5 is relevant
            if  table(5,8)~=0
                table(5,1)=(period-10)/10;              % get corresponding field
            end
    end
    if      intersect(period,periodset6)==period        % if period is in periodset6 and periodset6 is relevant
            if  table(6,8)~=0
                table(6,1)=(period-12)/12;              % get corresponding field
            end
    end
end                                                     % end of getperiod
